(*

This program reads in any necessary packages, 
sets up the routines that initialize the variables,
and takes care of housekeeping preliminaries 

*)

Print["Setting up the grids."];

(* % Create the grid points for x, s, and h   
   % by constructing a list of NumOfSteps points spaced evenly in 
   % utility between 0 and Log[max+1] and converting to levels
   % The NumOfSteps, the max's and min's are set in params.m *)

(*
lxgrid=Table[LoopOverxgrid,{LoopOverxgrid,(xmin+1)^(1-rho),(xmax+1)^(1-rho),((xmax+1)^(1-rho)-(xmin+1)^(1-rho))/NumOfxSteps}];
lsgrid=Table[LoopOversgrid,{LoopOversgrid,(smin+1)^(1-rho),(smax+1)^(1-rho),((smax+1)^(1-rho)-(smin+1)^(1-rho))/NumOfsSteps}];
lhgrid=Table[LoopOverhgrid,{LoopOverhgrid,(hmin+1)^(1-rho),(hmax-.5 PeriodsPerYear)^(1-rho),((hmax-.5 PeriodsPerYear)^(1-rho)-(hmin+1)^(1-rho))/NumOfhSteps}];

xgrid = lxgrid^(1/(1-rho))-1;
sgrid = lsgrid^(1/(1-rho))-1;
hgrid = lhgrid^(1/(1-rho))+.5 PeriodsPerYear;

*)


lxgrid=Table[LoopOverxgrid,{LoopOverxgrid,Log[xmax+1]/NumOfxSteps,Log[xmax+1],Log[xmax+1]/NumOfxSteps}];
lsgrid=Table[LoopOversgrid,{LoopOversgrid,Log[smax+1]/NumOfsSteps,Log[smax+1],Log[smax+1]/NumOfsSteps}];

(*
lhgrid=Table[LoopOverhgrid,{LoopOverhgrid,Log[hmax+1-.5 PeriodsPerYear]/NumOfhSteps,Log[hmax+1-.5 PeriodsPerYear],Log[hmax+1-.5 PeriodsPerYear]/NumOfhSteps}];
*)

(* Convert the evenly spaced log numbers to level form *)
xgrid = Exp[lxgrid] - 1;
sgrid = Exp[lsgrid] - 1;
hgrid = {};

(*
hgrid = Exp[lhgrid] - 1 + .5 PeriodsPerYear;
hgrid = Prepend[hgrid,.5 PeriodsPerYear];
hgrid = Append[hgrid,hsupermax];
*)

(* Prepend a couple of points very near the minima,
then prepend the minima *)
xgrid = Prepend[xgrid,xmin];
sgrid = Prepend[sgrid,smin];
hgrid = Prepend[hgrid,hmin];

xgrid = Prepend[xgrid,xmin+.1];
sgrid = Prepend[sgrid,smin+.1];

(* hgrid = Prepend[hgrid,hmin+.1]; *)
 
(*
xgrid = Prepend[xgrid,xmin+.01];
sgrid = Prepend[sgrid,smin+.01];
hgrid = Prepend[hgrid,hmin+.01];

*)
(*
xgrid = Append[xgrid,xmax-.1];
sgrid = Append[sgrid,smax-.1];
hgrid = Append[hgrid,hmax-.1];
*)
xgrid = Sort[xgrid];
sgrid = Sort[sgrid];
hgrid = Sort[hgrid];

<<tabulate_grids.m;
