(*
% Assuming that you have already solved for the current LifePosn, 
% construct the expectation of next periods Vt
*)

(* % Inititalize current life position state grid for solving *)

InStateGrid[[LifePosn]]  = InStateGridBaseline;
OutStateGrid[[LifePosn]] = OutStateGridBaseline;

(* % Add the current LifePosn to the each list of state variables *)

OutStateGridAugmented = AddOutcome[OutStateGrid[[LifePosn]],Table[LifePosn,{Length[OutStateGrid[[LifePosn]]]}]];

If[VerboseOutput == True,Print["Creating EtVtp1."]];

(* % Calculate the expected value of Vt for LifePosn+1 *)

EtVtp1Vals[[LifePosn]] =  Map[EtVtp1Raw,OutStateGridAugmented];

(* % Set up the data and functions to do EtVtp1 interpolation *)

EtVtp1InterpData[[LifePosn]] = AddOutcome[OutStateGrid[[LifePosn]],EtVtp1Vals[[LifePosn]]];
EtVtp1InterpFunc[[LifePosn]] = Interpolation[EtVtp1InterpData[[LifePosn]],InterpolationOrder->InterpOrder];
	
