(*
% Construct the data and interpolating functions for each of the important items. 
% Note that the function f(.) to be interpolated must be the last element in the list,
% so a seaparate list is generated for each of the variables we want to approximate. 
*)

Print["Running make_interpolating.m"];

VtInterpData[[LifePosn]] = AddOutcome[InStateGrid[[LifePosn]],Transpose[VtVals[[LifePosn]]][[VtPos]]];
VtInterpFunc[[LifePosn]]=Interpolation[VtInterpData[[LifePosn]],InterpolationOrder->InterpOrder];

ChoicetInterpData[[LifePosn]]=AddOutcome[InStateGrid[[LifePosn]],Transpose[VtVals[[LifePosn]]][[ChoicetPos]]];
ChoicetInterpFunc[[LifePosn]]=Interpolation[ChoicetInterpData[[LifePosn]],InterpolationOrder->1];

(* Print["ChoicetInterpFunc=
"<>ToString[ChoicetInterpFunc]]; *)

ctOptInterpData[[LifePosn]] = AddOutcome[InStateGrid[[LifePosn]],Transpose[VtVals[[LifePosn]]][[ctPos]]];
ctOptInterpFunc[[LifePosn]]=Interpolation[ctOptInterpData[[LifePosn]],InterpolationOrder->InterpOrder];

ztOptInterpData[[LifePosn]] = AddOutcome[InStateGrid[[LifePosn]],Transpose[VtVals[[LifePosn]]][[ztPos]]];
ztOptInterpFunc[[LifePosn]]=Interpolation[ztOptInterpData[[LifePosn]],InterpolationOrder->InterpOrder];

htOptInterpData[[LifePosn]] = AddOutcome[InStateGrid[[LifePosn]],Transpose[VtVals[[LifePosn]]][[htStartPos]]];
htOptInterpFunc[[LifePosn]]=Interpolation[htOptInterpData[[LifePosn]],InterpolationOrder->InterpOrder];

stOptInterpData[[LifePosn]] = AddOutcome[InStateGrid[[LifePosn]],Transpose[VtVals[[LifePosn]]][[stPosOut]]];
stOptInterpFunc[[LifePosn]]=Interpolation[stOptInterpData[[LifePosn]],InterpolationOrder->InterpOrder];

(* If[VerboseOutput == True,Print["Done with make_interpolating.m"]]; *)

(*
<<make_interpolating_findbest.m;
Save["solved_filledin_204_findbest.m",FindBestFunc];
*)
